<template>
  <article class="view view--forum-post-edit">
    <LoadingSpinner v-if="loading" />
    <PostUpdateForm v-if="loaded" :post="post" />
  </article>
</template>

<script>
import { ref, computed, onMounted, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import PostsApi from '../../api/posts-api.js'
import PostUpdateForm from '../../components/post-update-form.vue'

export default {
  name: 'ForumPostEditView',
  components: {
    LoadingSpinner,
    PostUpdateForm,
  },
  setup() {
    const route = useRoute()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const postsApi = new PostsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const post = ref(undefined)

    const postId = computed(() => {
      return ValidationHelper.getInteger(route.params.postId, 0)
    })

    const title = computed(() => {
      return 'Edit Post'
    })

    const iconClass = computed(() => {
      return route.meta.iconClass
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: post.value?.topic?.section?.displayName || 'Section',
          route: post.value?.topic?.section
            ? { name: 'forum-section', params: { codeName: post.value.topic.section.codeName } }
            : null,
        },
        {
          text: post.value?.topic?.title || '#',
          route: post.value?.topic ? { name: 'forum-topic', params: { alias: post.value.topic.alias } } : null,
        },
        {
          text: `Post #${postId.value}`,
          route: post.value?.topic
            ? {
                name: 'forum-topic',
                params: { alias: post.value.topic.alias, postId: postId.value },
                hash: `#post${postId.value}`,
              }
            : null,
        },
        {
          text: title.value,
          route: null,
        },
      ]
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      post.value = null

      try {
        const response = await postsApi.readAsync(postId.value, { expand: 'all' })
        post.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the post.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
      store.dispatch('core/setIconClass', iconClass.value)
    })

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    return {
      loading,
      loaded,
      post,
    }
  },
}
</script>
